#! /usr/bin/env python3
# -*- coding: utf-8 -*-
'''
Idee aus'm Buch: a primer on scientific rogramming

ein Ball wird mit einer gewissen Anfangsgeschwindigkeit 
senkrecht in die Hoehe geworfen
Wie hoch ist der Ball nach einer gewissen Zeit t?

basierend auf zweitem Newtonschen Axiom

hoehe(t) = v0*t - 0.5*g*t**2
wobei g mit 9.81m/s**2 angenommen wird.

hoehe(t) = t(v0 - 0.5*g*t)

der Anfangspunkt und der endpunkt des Balles muenden in hoehe = 0

0 = t(v0 - 0.5*g*t)

Ein produkt ist Null, wenn eines seiner Faktoren Null ist ==> 
t=0
v0 - 0.5*g*t == 0
v0 == 0.5*g*t
t = v0/(0.5*g)

Der Ball ist also 0 bis v0/0.5*g Sekunden lang in der Luft (haengt von v0 --> der Anfangsgeschwindigkeit) ab

Und wenn wir wissen, wie lange der Ball in der Luft ist bzw. von 0 bis zurueck zu 0 braucht, dann koennen wir innerhalb des Intervalls
zu jeder x-beliebigen Sekunde oder Bruchteil einer Sekunde
berechnen, wie hoch der Ball gerade ist.
'''

g = 9.81

def dauer(v0):
    return v0/(g/2)

def hoehe(v0, t):
    return v0*t - 0.5*g*t*t

def main():
    while True:
        v0 = input("wie gross soll die Anfangsgeschwindigeit sein? ")
        if v0.isdigit():
            v0 = int(v0)
            break
    wielange = dauer(v0)
    print( "der ball ist {} Sekunden in der Luft!".format( wielange))
    while True:
        wann = input('wie hoch ist Ball nach x Sekunden (Angabe kleiner {})'.format(wielange))
        try:
            wann = float(wann)
        except:
            continue
        break

    print("Nach {} Sekunden ist der Ball {} Meter hoch".format(wann, hoehe(v0, wann)))
if __name__ == '__main__':
    main()
