#! /usr/bin/env python3
'''
 caesar2.py
 Verschluesselung durch Substitution
 nach Caesar
 Buchstaben, Satzzeichen und Bindestrich werden ersetzt durch Nachbarzeichen
 diesmal sind aber die Nachbarzeichen variabel weit weg von cur_char.

 ich moechte wieder chr() und ord() einsetzen, diesmal aber eine Schwachstelle von caesar1.py beheben, denn da verwenden wir zwar NUR gross/kleinBuchstaben, aber auch die Sonderzeichen von chr(91) bis chr(96)!

 ord('A') == 65; ord('Z') == 90
 ord('a') == 97; ord('z') == 12)

 Die Reihenfolge ergibt sich zu Beginn (vor ord('A') aus
 >>> for i,j in enumerate(L):
...     print ('{}\t{}'.format(L[i], ord(j)))
... 
.   46
,   44
:   58
"   34
!   33
?   63
-   45
>>>

Aufgepasst:
Wenn man das Programm aufruft wie
./caesar2.py 'ich du er sie es!!' 3

kein Problem
./caesar2.py ich du er sie es 3

auch kein Problem
ABER - ungequotete ! am Ende werden von der bash INTERPRETIERT - also

./caesar2.py ich du er sie es!! 3

gibt eine Ueberraschung - da muesste man die ! quoten (volles quoting)
./caesar2.py ich du er sie es'!!' 3
'''

import os.path
import sys
from time import sleep

__author__ = 'michael poeltl'
__copyright__ = 'GPLv2'
__version__ = '0.02'

STELLEN = [ord('!'), ord('"'), ord(','), ord('-'),ord('.'),ord(':'),ord('?')] \
          + list(range(ord('A'),ord('Z')+1)) \
          + list(range(ord('a'),ord('z')+1))

def caesarz(z,rueckweite=0):
    '''nimmt eine Textzeile entgegen und baut sie um nach caesar
    '''
    satz = ''
    for c in z:
        #handling fuer alle non-letters
        if ord(c) not in STELLEN:
            satz += c
        #handling fuer x y z
        else:
            satz += chr(STELLEN[(STELLEN.index(ord(c))+rueckweite)%len(STELLEN)])
    return satz

def caesarf(f, rueckweite=0):
    '''nimmt file entgegen und wendet caesar an
    Buchstaben werden um drei Stellen nach rechts verschoben. Leerzeichen etc. werden unveraendert belassen.
    '''
    L = []
    for zeile in open(f).readlines():
        L.append(caesarz(zeile, rueckweite))
    return L

def main():
#da kommt noch argparse
#der Fall, dass keine Fueckweite angegeben wurde (und
#somit automatisch auf 0 gesetzt wird, ist noch nicht eingebaut!!
    if len(sys.argv) < 3:
        print ("Parameter fehlt", file=sys.stderr)
        sys.exit(1)
    print ('Verschluesseln durch Substitution nach Caesar\n')
    sleep(1)
    try:
        rueck = int(sys.argv[-1])
    except ValueError:
        print ('Falsche Angabe zur rueckweite!', file=sys.stderr)
        sys.exit(2)
    if os.path.isfile(sys.argv[1]):
        print ('\n'.join(caesarf(sys.argv[1], rueck)))
    else:
        print (caesarz(' '.join(sys.argv[1:-1]), rueck))

if __name__ == '__main__':
    main()
