#! /usr/bin/env python3
# -*- coding: utf-8 -*-

# Copyright (c) 2013 michael poeltl
# This program or module is free software: you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published
# by the Free Software Foundation, version 2.0 of the License
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
# It is provided for educational
# purposes and is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.

__author__ = 'michael poeltl'
__version__ = '0.01'
__license__ = 'GPLv2.0'
__email__ = 'michael.poeltl@univie.ac.at'
__copyright__ = 'poeltl (c) 2013'

def list_or_tuple(x):
    '''is x a tuple or a list?
    '''
    return isinstance(x, (list, tuple))

def l_t_s_f(x):
    '''
    checks, if given object is
    a list, tuple, set or frozenset
    SYNTAX:
    l_t_s_f( x )
    '''
    return isinstance( x, (list,tuple,set,frozenset) )

def flattern(seq, to_expand=l_t_s_f):
    for item in seq:
        if to_expand(item):
            for subitem in flattern(item, to_expand):
                yield subitem
        elif isinstance(item, dict):
            for subitem in flattern(item.values(),to_expand):
                yield subitem
        else:
            yield item

if __name__ == '__main__':
    #D = [['erste_l',['sub-list',2,['subsub',5,['subsubsub',{'eins':1,2:{'drei':3}},3]]]]]
    D = [(1,2),(3,(4,5),(6,7))]
    for w in flattern(D):
        print (w)

