#! /usr/bin/env python3

'''
reverse_caesar3.py
Jetzt sollen wir caesar3-code dechiffrieren
'''

import os.path
import sys
import string
from time import sleep

__author__ = 'michael poeltl'
__copyright__ = 'GPLv2'
__version__ = '0.01'

#  Zum Dechiffrieren muessten wir die Zeichen durch einen Nachbarn
#+ LINKS vom Chiffre ersetzen -
#+ hmmmm - kompliziert -
#+ einfacher ist es, einfach die Zeichenkette ZEICHEN umzudrehen
#+ und wieder nach rechts zu ruecken ;-)
ZEICHEN = (string.punctuation[:15] \
          + string.digits \
          + string.punctuation[15:] \
          + string.ascii_uppercase \
          + string.ascii_lowercase)[::-1]

def caesarz(z,rueckweite=0):
    '''nimmt eine Textzeile entgegen und baut sie um nach caesar
    '''
    satz = ''
    for c in z:
        #handling fuer alle unbekannten Zeichen
        if c not in ZEICHEN:
            satz += c
        #handling fuer bekannte Zeichen
        else:
            satz += ZEICHEN[(ZEICHEN.index(c)+rueckweite)%len(ZEICHEN)]
    return satz

def caesarf(f, rueckweite=0):
    '''nimmt file entgegen und wendet caesar an
    '''
    L = []
    for zeile in open(f).readlines():
        L.append(caesarz(zeile, rueckweite))
    return L
 
def main():
    #krach wenn kein Parameter uebergeben wurde
    if len(sys.argv) == 1:
        print ("Parameter fehlt. Nothing to do!", file=sys.stderr)
        sys.exit(1)
    print ('Verschluesseln durch Substitution nach Caesar\n')
    sleep(1)
    while True:
        rueck = input('Wie weit soll nach rechts verschoben werden? ')
        if rueck.isdigit():
            rueck = int(rueck)
            break
        else:
            print ("Falsche Eingabe. Bitte noch einmal!")
    if len(sys.argv) == 2:
        if os.path.isfile(sys.argv[1]):
            print ('\n'.join(caesarf(sys.argv[1], rueck)))
        else:
            print (caesarz(sys.argv[1], rueck))
    else:
        print (caesarz(' '.join(sys.argv[1:]), rueck))

if __name__ == '__main__':
    main()
