#! /usr/bin/env python3

'''
users2.py
Einfaches OOP Beispiel.
Enthaelt zwei Klassen: Nisuer und Alluser
ueber ein datafile (pickle) kommt man zu den Daten
bzw. legt man die Aenderungen dort ab
'''

import os
import pickle

__author__ = 'michael poeltl'
__license__ = 'GPLv2'
__copyright__ = 'michael poeltl (c) 2011'
__email__ = 'michael.poeltl[ AT ]univie.ac.at'
__version__ = '0.01'

class Nisuser:
    '''all current user in nis from inst-lan'''
    def __init__(self):
        self.userlist = os.path.join(os.environ['DATA'],'pickle','nisusers')
        if not os.path.exists(self.userlist):
            f = open(self.userlist, 'w')
            f.close()
    def adduser(self, user):
        '''adding users to currlist'''
        with open(self.userlist, 'rb') as f:
            try:
                ul = pickle.load(f)
            except:
                ul = []
        if isinstance(user, str):
            if user not in ul:
                ul.append(user)
        elif isinstance(user, list) or isinstance(user, tuple):
            for u in user:
                if u not in ul:
                    ul.append(u)
        with open(self.userlist, 'wb') as f:
            pickle.dump(ul, f)
        return None

    def deluser(self, user):
        '''remove user from userlist'''
        with open(self.userlist, 'rb') as f:
            ul = pickle.load(f)
        if isinstance(user, str):
            ul.remove(user)
        elif isinstance(user, list) or isinstance(user, tuple):
            for u in user:
                if u in ul:
                    ul.remove(u)
        with open(self.userlist, 'wb') as f:
            pickle.dump(ul, f)
        return None

    def getuser(self, user):
        with open(self.userlist, 'rb') as f:
            #ul = pickle.load(f)
            return user in pickle.load(f)

    def getlist(self):
        with open(self.userlist, 'rb') as f:
            return pickle.load(f)
    def getnum(self):
        with open(self.userlist, 'rb') as f:
            return len(pickle.load(f))

class Alluser(Nisuser):
    def __init__(self):
        self.userlist = os.path.join(os.environ['DATA'], 'pickle', 'allusers')
        if not os.path.exists(self.userlist):
            f = open(self.userlist, 'w')
            f.close()

if __name__ == '__main__':
    nuser = Nisuser()
    auser = Alluser()
    print (nuser.getlist())
    print ("{} user im NIS".format(nuser.getnum()))
    print ('='*70)
    print (auser.getlist())
    print ("{} user ever since beginning".format(auser.getnum()))
    print ("{} ist nisuser".format('poeltl') if nuser.getuser('poeltl') else '{} ist kein nis user'.format('poeltl'))
    print ("{} ist nisuser".format('krankl') if nuser.getuser('krankl') else '{} ist kein nis user'.format('krankl'))
