#! /opt/bin/python3

'''
Fueller sollten die *Haeufigkeitsattacke* der
Kruptoanalytiker erschweren bis unmoeglich machen

Idee war die, das Alphabet (26 Buchstaben) durch Zahlen zu ersetzen,
aber nicht durch 1 bis 2, sondern durch Zahlen zwischen 1 und 100 - jeder Buchstabe hat eine gewisse Zahl, alle anderen Zahlen im Zahlenbereich sind Fueller, und erschweren somit die haeufigkeitsanalyse

Dieses Programm ist vorerst einmal eie erste Idee einer moeglichen Umsetzung
'''

import string
import os.path
import pprint
from random import shuffle
from atbasch import eingabe

__author__  = 'michael.poeltl'
__version__ = '0.01'

RANGE    = 600
INDICES  = [ str(i) for i in range( RANGE ) if not i%6]
_OTHERS   = [ str(i) for i in range( RANGE ) if str(i) not in INDICES]
shuffle( _OTHERS)
FUELLER  = _OTHERS[:100]
DECHIFF  = { INDICES[i]:string.printable[ i ] for i in range( len(string.printable)) }
CHIFF    = { j:i for i,j in DECHIFF.items()}
MAXFUELL = list( range(5))

def chiffrier(text=''):
    _chifftext = []
    chifftext = ''
    if os.path.isfile( text ):
        zeichen = open( text ).read()
    else:
        zeichen = text
    for c in zeichen:
        shuffle( FUELLER )
        shuffle( MAXFUELL )
        _chifftext.extend(FUELLER[: MAXFUELL[0] ])
        if c in CHIFF:
            _chifftext.append(CHIFF[ c ])
    for i in range(1, len(_chifftext)+1):
        if not i%30:
            chifftext += '\n'
        else:
            chifftext += _chifftext[i-1]
            chifftext += ' '
    return chifftext

def dechiffrier(text=''):
    if os.path.isfile(text):
        chiff = open(text).read().split()
    else:
        chiff = text.split()
    indices = [ i for i in chiff if i in INDICES]
    dechiff = ''
    for i in indices:
        dechiff += DECHIFF[ i ]
    return dechiff

def main():
    wahl1,wahl2,dinx = eingabe()
    if wahl1 == '1':
        ergebnis = chiffrier( dinx )
        if wahl2 == '1':
            print("Speichere Ergebnis in /tmp/fuellchiff")
            with open('/tmp/fuellchiff', 'w') as f:
                f.write(ergebnis)
        else:
            pprint.pprint( ergebnis )
    elif wahl1 == '2':
        ergebnis = dechiffrier( dinx )
        if wahl2 == '1':
            print("Speichere Ergebnis in /tmp/fuelldechiff")
            with open('/tmp/fuelldechiff', 'w') as f:
                f.write(ergebnis)
        else:
            pprint.pprint( ergebnis )

if __name__ == '__main__':
    main()
