'''
merken

identifiers:
\d ... irgendeine Zahl
\D ... ALLES ausser einer Zahl
\s ... Leerzeichen (space)
\S ... alles AUSSER space
\w ... irgendein Buchstabe
\W ... alles ausser einem Buchstaben
.  ... jedes druckbare Zeichen ausser der "newline" \n
\b ... whitespace vor/nach einem Wort
\. ... der Punkt

modifiers:
{ 1,3 } ... mindestens 1 und maximal 3 von *etwas*:  \d{1,3}
+       ... 1 oder mehr Zeichen
?       ... 0 oder 1 match  von dem VOR dem Fragezeichen
*       ... 0 oder mehr
$       ... match end of string
^       ... meint Anfang vom string
|       ... ODER
[]      ... Bereichsangaben

whitespace:
\s ... space
\t ..  Tabstpo
\n ... newline
\r ... carriage return
\e ... escape
\f ... form feed

'''
import re

teststring = '''Maggie ist 5 jahre alt, Michelle ist 12 jahre alt\nund ihr Papa ist bereits 48 jahre alt, aber die Mama, chenny, ist erst 40 jahre alt.
'''

altersangaben = re.findall(r'\d{1,3}', teststring)
namen = re.findall(r'[A-Z][a-z]+', teststring)

print( altersangaben )
print( namen )

ndict = dict()
altersangaben.reverse()
for name in namen:
    ndict[name] = altersangaben.pop()

print( ndict )
