#! /opt/bin/python3
'''
fibo_proxy will zeigen, dass die Zahlen in der fibo-Reihe noch ein Geheimnis in sich tragen.
Dividiert man eine fibo-Zahl durch ihren Vorgaenger, so naehert sich der Quotient ziemlich rasch dem Quotienten
des Goldenen Schnitts - ziemlich rasch schon erhaelt man
1.61803398874989490252573887119069695472717285156250
'''

__author__  = 'michael poeltl'
__version__ = '0.02'

def fibo():
    a,b = 0,1
    while True:
        a,b = b,a+b
        yield a

def main():
    print( "Fibo Proxy")
    print( """dividiert man eine Fibo-Zahl mit ihrem Vorgaenger, so kann das als
              Naeherungswert gesehen werden zur Zahl des goldenen Schnitts. Je
              groeser die fibo-Zahl umso genauer""")
    while True:
        try:
            print( """Berechnung nach zwei Umlaeufen hat schon eine gute genauigkeit.
Berechnung ab dem dritten Umlauf ist schon sehr sehr genau.""")
            umlaeufe = int( input("wieviele Umlaeufe (mind. 2)? ") )
            if umlaeufe == 1:
                raise ValueError("Umlaeufe muss groesser 1 sein")
            break
        except ValueError as e:
            print("Falsche Eingabe (siehe {})".format( e ))
            continue
    fibozahlen = fz = fibo()
    count = 0
    for umlauf in range( umlaeufe ):
        count += 20
        for i in range(18):
            next( fz )
        a = next( fz )
        b = next( fz )
        print( 'Nach {} Umlaeufen:\n{:.50f}'.format( count, b/a ))

if __name__ == '__main__':
    main()
