#! /opt/bin/python3

'''
erste Berechnungen fuer den Goldenen Schnitt
 nachdem ich "Geschichte der Mathematik"
(Teil 1) gesehen habe
der goldene Schnitt wurde erklaert
zwei Strecken stehen im Verhaeltnis des goldenen schnitts, wenn
die groessere zur kleineren im selben Verhaeltnis steht wie
die Summe der beiden zur groesseren!

l:b == (l+b):l
Satz von Vieta
l ist bekannt
l^2 = b^2 +b*l ==>
b^2 + l*b - l^2 == 0

b ist bekannt:
l^2 -b*l - b^2 == 0

changelog zu v0.02
Rundungsfehler in teile_gold() korrigiert
'''

__author__ = 'michael poeltl'
__version__ = '0.03'

def get_gold(bekannt = 0, klein = False):
    '''
    finde zu einer gegebenen Strecke
    die 'passende', sodass die laengere zur kleineren
    im Verhaeltnis des goldenen schnitts steht
    bekannt ... die bekannte Strecke
    klein   ... ist 'bekannt' die kleinere Strecke?
    '''
    phalbe = ( bekannt/2 ) if klein else ( bekannt/2 ) * -1
    p2viertel = ( bekannt**2)/4
    q = bekannt**2
    wurzel = ( p2viertel + q )**0.5
    #  return (phalbe + wurzel, phalbe - wurzel)
    #+ wir brauchen nur phalbe + wurzel
    return phalbe + wurzel

def _teile_golden(gross,klein):
    return (gross**2)/klein

def teile_golden(strecke):
    '''
    teile eine Strecke in zwei Teilstrecken, die
    zueinander im Verhaeltnis des Goldenen Schnitts
    stehen
    '''
    if strecke == 0:
        return (0,0,)
    elif strecke <= 1:
        klein,runto = strecke,1
    elif strecke < 30:
        runto = int(strecke)
    else:
        runto = int(strecke) // 2
    for i in range(1,runto):
        if _teile_golden(strecke-i,i) == strecke:
            print("Teffer")
            return (strecke-i,i,)
        else:
            #ab wann ist _teile_golden kleiner strecke?
            _try = _teile_golden(strecke-i,i)
          #  print("debug: i={}, try={}, strecke={}".format(i,_try,strecke))
            if _try < strecke:
                klein = i
                break
    #  loesung liegt zwischen klein und klein-1, weil ja dr 
    #+ quotient von (strecke-klein)**2/klein kleiner als die Strecke war
    kleiner = klein-1
    for i in range(100000):
        kmittel = (klein+kleiner)/2
        versuch =  _teile_golden(strecke - kmittel,kmittel)
        if versuch == strecke:
            return (strecke-kmittel,kmittel)
        elif versuch < strecke:
            klein = kmittel
        else:
            kleiner = kmittel
    #kmittel = (klein+kleiner)/2
    laenger = get_gold(kmittel, True)
    return ( laenger ,kmittel)
    #  return (strecke-kmittel,kmittel)
    #+ strecke-kmittel hat an der letzten kommastelle einen Rundungsfehler

def main():
    print("ad Goldener Schnitt:")
    while True:
        strecke = input("Gib die Laenge der Strecke an: ")
        try:
            strecke = float(strecke)
        except ValueError as e:
            print( "Fehlerhafte Eingabe. Siehe {}".format( e ) )
            continue
        break
    print('''
           Ist die Angabe
           1 die laengere Strekc?
           2 die kuerzere Strecke
           3 die Strecke, die im Goldenen Schnitt geteilt werden soll?
          '''
         )
    while True:
        wahl = input("Deine Wahl? ")
        try:
            wahl = int( wahl )
        except ValueError:
            print( "Wahle aus: 1 oder 2 oder 3" )
            continue
        if wahl in (1,2,3):
            break
        else:
            print( "Wahle aus: 1 oder 2 oder 3" )
    if wahl == 1:
        ist_kleine = False
        klein = get_gold( strecke, ist_kleine )
        gross = strecke
    elif wahl == 2:
        ist_kleine = True
        gross = get_gold( strecke,ist_kleine )
        klein = strecke
    else:
        gross,klein = teile_golden( strecke )

    if wahl == 3:
        print("{:>20}{}{}".format('gegebene Strecke',' = ', strecke ))
    print( "{:>20}{}{}\n{:>20}{}{}".format(
                                          'laengere Strecke = l',
                                          ' = ',
                                          gross,
                                          'kuerzere Strecke = k',
                                          ' = ',
                                          klein
                                         ))
    print( "{:>20}{}{:.50f}".format('l : k',' = ', gross/klein ))
    print( "{:>20}{}{:.50f}".format('(l + k) : l',' = ', (gross+klein)/gross))
    if wahl == 3:
        print( "{:>20}{}{:.50f}".format('strecke : l',' = ', strecke/gross))

if __name__ == '__main__':
    main()
