#! /opt/bin/python3
'''
pseudo_fibo soll zeigen, dass schon der
Algorithmus der fibonacci-Reihe reicht, um
am Ende phi zu bekommen (1.6...)

also man beginnt nicht mit 0 1, sondern mit irgendwelchen Zahlen
n0 < n1 (n aus der Menge der natuerlichen Zahlen
'''

__author__  = 'michael poeltl'
__version__ = '0.01'

def fibo(n0=0,n1=1):
    a,b = n0,n1
    while True:
        a,b = b,a+b
        yield a

def main():
    print( "Berechnung von phi nach Algorithmus von fibonacci-Reihe")
    print( "zuerst muss ich wissen, mit welchen Zahlen die Reihe\nbeginnen soll")
    while True:
        try:
            erste = input("Wie lautet die erste Zahl der Reihe? ")
            if erste.isdecimal():
                erste = int(erste)
                break
            else:
                raise ValueError("Erste Zahl muss eine natuerliche Zahl sein!")
        except ValueError as e:
            print("Falsche Eingabe: '{}'".format(e))
            continue
    while True:
        try:
            zweite = input( "Wie lautet die zweite Zahl?\nZweite Zahl muss groesser sein, als die erste Zahl und muss ebenfalls eine natuerliche Zahl sein! ")
            if zweite.isdecimal():
                zweite = int(zweite)
                if zweite > erste:
                    break
                else:
                    raise ValueError("Die zweite Zahl muss groesser sein als die erste Zahl!")
            else:
                raise ValueError("Zweite Zahl muss eine natuerliche Zahl sein!")
        except ValueError as e:
            print("Falsche Eingabe: '{}'".format(e))
            continue

    while True:
        try:
            print( """Berechnung nach zwei Umlaeufen hat schon eine gute genauigkeit.
Berechnung ab dem dritten Umlauf ist schon sehr sehr genau.""")
            umlaeufe = int( input("wieviele Umlaeufe (mind. 2)? ") )
            if umlaeufe == 1:
                raise ValueError("Umlaeufe muss groesser 1 sein")
            break
        except ValueError as e:
            print("Falsche Eingabe (siehe {})".format( e ))
            continue
    fibozahlen = fz = fibo()
    count = 0
    for umlauf in range( umlaeufe ):
        count += 20
        for i in range(18):
            next( fz )
        a = next( fz )
        b = next( fz )
        print( 'Nach {} Umlaeufen:\n{:.50f}'.format( count, b/a ))

if __name__ == '__main__':
    main()
