#! /usr/bin/env python3

'''
zeigt function annotation zum Einen
und how to check arguments (*args, **kw) zum Anderen

function annotation gibt es erst seit python3.0 (nonexistent in python2X) - code st
demnach mit Sicherheit backward incompatible
'''

import functools
import inspect
from itertools import chain

def typesafe(func):
    '''aout of book "Pro Python" p. 79ff
    typesafe checks if he given type in form of an annotation was valid
    '''
    spec = inspect.getfullargspec(func)
    annotations = spec.annotations
    for name, annotation in annotations.items():
        if not isinstance(annotation, type):
            raise TypeError('The annotatin for {} is not a type'.format(name))
    error = 'wrong type for {}; expected {}, got {}'#brauchen wir oefter
    @functools.wraps(func)
    def wrapper(*args, **kw):
        #check keyword arguments
        ##for name,arg in kw.items():
        for name, arg in chain(zip(spec.args, args), kw.items()):
            if name in annotations and not isinstance(arg, annotations[name]):
                raise TypeError(error.format(name, annotations[name].__name__,
                                             type(arg).__name__))
        return func(*args, **kw)
    return wrapper

@typesafe
def rectangle(laenge:int, breite:int) ->int:
    return float(laenge*breite)

def main():
    laenge = 17
    breite = 5
    area = rectangle(laenge,breite)
    print ('Das Rechteck mit l = {} und b = {} hat eine Flaeche von {}'.format(laenge, breite, area))

if __name__ == '__main__':
    main()
