#! /usr/bin/env python3

'''
    All about prime-Numbers:
    >>> from mp_math.mp_prim import is_prim
    >>> is_prim(4)
    False
    >>> is_prim(17)
    True
    >>>
'''
from math import sqrt

__author__ = 'michael poeltl'
__version__ = '0.02'
__copyright__ = 'michael poeltl (c) 2010'
__license__ = 'GPLv2'

def is_prim(n):
    '''
    checks, if n is a prime number, or not
    >>> from mp_math.mp_prim import is_prim
    >>> is_prim(53)
    True
    >>>
    '''
    if n in (2,3,5,7,11,13,17,19):
        return True
    elif n < 2 or n%2==0 or n%3==0 or n%5==0 or n%11==0 or n%13==0 or n%17==0:
        return False
    else:
        for i in range(7,(int(sqrt(n))+1),2):
            if n%i == 0:
                return False
    return True

if __name__ == '__main__':
    import doctest
    doctest.testmod()
