#! /usr/bin/env python3

'''
    quadratisch.py
    quadratische gleichungen loesen
    x^2+2X-8 = 0 oder 4x^2 -2x+19 = 0
    gibt es dafuer ueberhaupt eine reale Loesung?

    Die Formeln lauteten:
    x1,x2 = (-b +- sqrt(b**2-4ac))/2a (ax^2 + bx +c = 0)

    >>> from mp_math.quadratisch import get_res
    >>> get_res(18,12,0)
    (0.0, -0.6666666666666666)
    >>> get_res(18,10,0)
    (0.0, -0.5555555555555556)
    >>> get_res(5,0,-5)
    (1.0, -1.0)
    >>>
'''
import math

__author__ = 'michael poeltl'
__version__ = '0.01'
__copyright__ = 'michael poeltl (c) 2011'
__license__ = 'GPLv2'

def get_res(a=0, b=0, c=0):
    '''
    computes x1 and x2 if exists
    >>> from mp_math.quadratisch import get_res
    >>> get_res(1,2,3)
    False
    >>> get_res(1,2,-3)
    (1.0, -3.0)
    >>>
    
    '''
    if a == 0 and b == 0:
        return False
    elif a == 0:
        return (-c/b, )
    else:
        try:
            wurzel = math.sqrt(b**2 - 4*a*c)
        except ValueError:
            return False
        else:
            nenner = a*2
            return ((-b + wurzel)/nenner, (-b - wurzel)/nenner, )



if __name__ == '__main__':
    import doctest
    doctest.testmod()
