#! /usr/bin/env python3
# -*- coding: utf-8 -*-

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#        # This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License at http://www.gnu.org/licenses/gpl.txt
# By using, editing and/or distributing this software you agree to
# the terms and conditions of this license.

'''
possible_words.py uebernimmt eine Anzahl von Zeichen und gibt Woerter aus, die sich mit diesen Zeichen bilden lassen. Dazu habe ich files voll mit den verschiedensten Woertern. Viele Wort-files sind gzipped, also werden wir uns auch mit dem gzip-Modul in diesem python-Programm beschaeftigen muessen.
Es ist der erste Versuch - 
viele Verbesserungen fliessen in Folgeversionen ein

Dieses script zeigt, was ich eigentlich will
'''

__author__ = 'michael poeltl'
__license__ = 'GPLv2'
__version__ = '0.01'

from random import shuffle
import sys
import re

MAX_NUM_CHARS = 6
VERSUCH = '/home/poeltl/work/worte/miscworte'

gefunden = []

def fakt(s):
    '''errechnet die Anzahl an Kombinationsmoeglichkeiten
    z.B.: s = 'abcd'
    sK = 4*3*2*1
    '''
    n = 1
    x = len(s)
    while x > 1:
        n *= x
        x -= 1
    return n

def svar(s):
    '''schuettelt s so oft durcheinander, bis alle
    Kombinationsmoeglichkeiten von Zeichen in s gefunden wurden
    geht schnell genug bis 6Zeichen, 7Zeichen gehen auch noch
    aber ab 8Zeichen dauerts! -> bedarf eines besseren Algorithmus
    '''
    L = []
    while len(L) < fakt(s):
        _L = list(s)
        shuffle(_L)
        f = ''.join(_L)
        if f not in L:
            L.append(f)
    return L

def regexp(s):
    wordlist svar(s)
    rL = []
    while wordlist:
        wL = list(wordlist.pop())
        r = r'.*'
        for c in wL:
            r += c+r'.*'
        rL.append(re.compile(r))
    return rL

def main():
    if len(sys.argv[1]) <= MAX_NUM_CHARS:
        buchstaben = sys.argv[1]
    else:
        print ("max number of characters is 6!\nTry Again")
        sys.exit(0)
    muster = regexp(buchstaben)




if __name__ == '__main__':
    main()
