#! /usr/bin/env python3

'''
Summation of primes
Problem 10
The sum of the primes below 10 is 2 + 3 + 5 + 7 = 17.

Find the sum of all the primes below two million.

'''
from math import ceil

__author__ = 'michael poeltl'
__version__ = '0.01'
__license__ = 'GPLv2'

def isprim(n):                                                                 
    '''
    is n a prime-number?
    SYNTAX: isprim(integer)
    ret-val is True|False
    '''
    if n < 2:
        return False
    if n in (2,3,5,7,11,13,17,19,23,29):
        return True
    elif n % 2 == 0:
        return False
    for i in range(3,ceil(n**0.5)+10,2):
        if n % i == 0:
            return False
    return True

def main():
    summe = 2
    for i in range (3,2000000,2):
        if isprim(i):
            summe += i

    print ('die Summe ist {}'.format(summe))

if __name__ == '__main__':
    main()
