#! /usr/bin/env python3

'''
Number letter counts
Problem 17

If the numbers 1 to 5 are written out in words: one, two, three, four, five, then there are 3 + 3 + 5 + 4 + 4 = 19 letters used in total.

If all the numbers from 1 to 1000 (one thousand) inclusive were written out in words, how many letters would be used?

NOTE: Do not count spaces or hyphens. For example, 342 (three hundred and forty-two) contains 23 letters and 115 (one hundred and fifteen) contains 20 letters. The use of "and" when writing out numbers is in compliance with British usage.

'''
def kleiner_zehn(szahl) -> str:
    return ZAHLEN[szahl]

def kleiner_hundert(szahl) -> str:
    if szahl in ZAHLEN:
        return ZAHLEN[szahl]
    else:
        return ZAHLEN[szahl[0]+'0'] + ZAHLEN[szahl[1]]

def kleiner_tausend(szahl):
    if szahl[1:] == '00':
        vorne = kleiner_zehn(szahl[0])
        return vorne+ZAHLEN['100']
    elif szahl[1] == '0':
        vorne = kleiner_zehn(szahl[0])
        einer = kleiner_zehn(szahl[-1])
        return vorne+ZAHLEN['100']+'and'+einer
    else:
        vorne = kleiner_zehn(szahl[0])
        return vorne+ZAHLEN['100']+'and'+kleiner_hundert(szahl[1:])


ZAHLEN = {
        '1'    : 'one',
        '2'    : 'two',
        '3'    : 'three',
        '4'    : 'four',
        '5'    : 'five',
        '6'    : 'six',
        '7'    : 'seven',
        '8'    : 'eight',
        '9'    : 'nine',
       '10'    : 'ten',
       '20'    : 'twenty',
       '30'    : 'thirty',
       '40'    : 'forty',
       '50'    : 'fifty',
       '60'    : 'sixty',
       '70'    : 'seventy',
       '80'    : 'eighty',
       '90'    : 'ninety',
      '100'    :'hundred',
     '1000'    :'thousand',
       '11'    :'eleven',
       '12'    :'twelve',
       '13'    :'thirteen',
       '14'    :'fourteen',
       '15'    :'fifteen',
       '16'    :'sixteen',
       '17'    :'seventeen',
       '18'    :'eighteen',
       '19'    :'nineteen'
        }

def main():
    while True:
        try:
            ENDNUM = eval(input("""Bitte Zahl eingeben, bis zu welcher
            die Buchstaben der *geschriebenen* englischen Zahlen aufsummiert
            werden sollen (Obergrenze ist 1000): """))
            if isinstance(ENDNUM, int):
                break
        except:
            continue
    summe = 0
    for i in range(1,ENDNUM+1):
        c = str(i)
        if i < 10:
            print ("{} -> {} anzahl-char = {:>20}".format(c,kleiner_zehn(c),len(ZAHLEN[c])))
            summe += len(ZAHLEN[c])
        elif i < 100:
            wortlaut = kleiner_hundert(str(i))
            summe += len(wortlaut)
            print ("{} -> {} anzahl-char = {:>20}".format(i,wortlaut,len(wortlaut)))
        elif i < 1000:
            wortlaut = kleiner_tausend(str(i))
            summe += len(wortlaut)
            print ("{} -> {} anzahl-char = {:>20}".format(i,wortlaut,len(wortlaut)))
        elif i == 1000:
            print ("{} -> {} anzahl-char = {:>20}".format(i,'onethousand',len('onethousand')))
            summe += len('onethousand')
            print ("Hoechstmoegliche Zahl wurde erreicht!")
            break




    print('summe aller zeichen der ausgeschriebenen englischen Zahlen von 1 bis {} ist\n{}'.format(ENDNUM,summe))


if __name__ == '__main__':
    main()
