#! /usr/bin/env python3

'''
siehe
http://projecteuler.net/problem=2

Each new term in the Fibonacci sequence is generated by adding the previous two terms. By starting with 1 and 2, the first 10 terms will be:

1, 2, 3, 5, 8, 13, 21, 34, 55, 89, ...

By considering the terms in the Fibonacci sequence whose values do not exceed four million, find the sum of the even-valued terms.
'''

__author__ = 'michael poeltl'
__version__ = '0.01'
__license__ = 'GPLv2'

def fibo():
    a,b = 0,1
    while True:
        a,b = b,a+b
        yield a

def main():
    summe = 0
    f = fibo()
    while True:
        x = f.__next__()
        if x >= 4000000:
            break
        elif not x%2:
            summe += x

    print ("die Summe aller geraden fibonacchi-Zahlen kleiner als vier Millionen betraegt {}".format(summe))

if __name__ == '__main__':
    main()
