#! /usr/bin/env python3

'''
Names scores
Problem 22

Using names.txt (right click and 'Save Link/Target As...'), a 46K text file containing over five-thousand first names, begin by sorting it into alphabetical order. Then working out the alphabetical value for each name, multiply this value by its alphabetical position in the list to obtain a name score.

For example, when the list is sorted into alphabetical order, COLIN, which is worth 3 + 15 + 12 + 9 + 14 = 53, is the 938th name in the list. So, COLIN would obtain a score of 938 × 53 = 49714.

What is the total of all the name scores in the file?
download-link of names.txt is
http://projecteuler.net/project/names.txt

'''

from string import ascii_uppercase as grossbuchstaben

def summe_stellenwert(name):
    return sum([ grossbuchstaben.find(x)+1 for x in name ])

def main():
    namensliste = [ x.strip('"') for x in open('names.txt').read().split(',')]
    namensliste.sort()
    summe = sum([ (namensliste.index(x)+1)*summe_stellenwert(x) for x in namensliste])
    print (summe)



if __name__ == '__main__':
    main()
