#! /usr/bin/env python3
# -*- coding: utf-8 -*-
'''
Lexicographic permutations
Problem 24
A permutation is an ordered arrangement of objects. For example, 3124 is one
possible permutation of the digits 1, 2, 3 and 4. If all of the permutations
are listed numerically or alphabetically, we call it lexicographic order.
The lexicographic permutations of 0, 1 and 2 are:
    012   021   102   120   201   210

What is the millionth lexicographic permutation of the digits
0, 1, 2, 3, 4, 5, 6, 7, 8 and 9?

Sh> time python3 euler_project_24.py
alle gefunden
2783915460

real    0m16.004s
user    0m15.865s
sys     0m0.136s
Sh>
'''
# Copyright (c) 2013 michael poeltl
# This program or module is free software: you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published
# by the Free Software Foundation, version 2.0 of the License
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
# It is provided for educational
# purposes and is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
#itsme@nug:~$ python3 work/uniweb/py/bsp/project_euler/euler_project_24.py
#['2', '3', '4', '5', '6', '7', '8', '9']
#3 * fakt(9) ist 1088640
#laenge sammel = 1088640
#2783915460
#itsme@nug:~$

__author__ = 'michael poeltl'
__version__ = '0.02'
__license__ = 'GPLv2.0'
__email__ = 'michael.poeltl@univie.ac.at'
__copyright__ = 'poeltl (c) 2013'

from math import factorial
from random import shuffle

SATZ = '123456789'
MAXFIVE = factorial(5)
MAXPERMUTATIONS_FOR_SATZ = MAXLEN = factorial(9)
MAXPERMUTATIONS_FOR_ALL_TEN_DIGITS_FROM_0_TO_9 = MAXALLTEN = factorial(10)


def get_pre():
    for i in range(1234,10000):
        pre = str(i)
        if '0' in pre or len(set(pre)) < 4:
            continue
        else:
            yield pre

def get_fivepack(to_role):
    fivepack = []
    while len(fivepack) < MAXFIVE:
        shuffle(to_role)
        if ''.join(to_role) in fivepack:
            continue
        else:
            fivepack.append(''.join(to_role))
    return fivepack

def main():
    sammlung_aller = []
    sammlung_neuner = []
    vier = get_pre()
    while len(sammlung_neuner) < MAXLEN:
        pre = next(vier)
        fivepack = get_fivepack( [ c for c in SATZ if c not in pre ]) 
        for j in fivepack:
            sammlung_neuner.append( pre + ''.join(j) )
    sammlung_aller = [ i+j.replace(i,'0') for i in '0'+SATZ for j in sammlung_neuner ]
    if len(sammlung_aller) == MAXALLTEN:
        print ('alle gefunden')
    sammlung_aller.sort()
    print (sammlung_aller[999999])


if __name__ == '__main__':
    main()
