#! /usr/bin/env python3
# -*- coding: utf-8 -*-
'''
1000-digit Fibonacci number
Problem 25
The Fibonacci sequence is defined by the recurrence relation:

Fn = Fn1 + Fn2, where F1 = 1 and F2 = 1.
Hence the first 12 terms will be:

F1 = 1
F2 = 1
F3 = 2
F4 = 3
F5 = 5
F6 = 8
F7 = 13
F8 = 21
F9 = 34
F10 = 55
F11 = 89
F12 = 144
The 12th term, F12, is the first term to contain three digits.

What is the first term in the Fibonacci sequence to contain 1000 digits?
'''
# Copyright (c) 2013 michael poeltl
# This program or module is free software: you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published
# by the Free Software Foundation, version 2.0 of the License
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
# It is provided for educational
# purposes and is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.

__author__ = 'michael poeltl'
__version__ = '0.01'
__license__ = 'GPLv2.0'
__email__ = 'michael.poeltl@univie.ac.at'
__copyright__ = 'poeltl (c) 2013'

def fibo():
    a,b = 0,1
    while True:
        a,b = b,a+b
        yield a

def main():
    fibonacci = fibo()
    count = 1
    while True:
        zahl = fibonacci.__next__()    
        if len(str(zahl)) >= 1000:
            print ("Die {}. fiboZahl hat als erste 1000 Stellen".format(count))
            break
        elif len(str(zahl)) < 3:
            print ('count:{}  zahl: {}'.format(count,zahl))
        count += 1
            

if __name__ == '__main__':
    main()
