#! /usr/bin/env python3
# -*- coding: utf-8 -*-
'''
Number spiral diagonals
Problem 28
Starting with the number 1 and moving to the right in a clockwise direction a 5 by 5 spiral is formed as follows:

21 22 23 24 25
20  7  8  9 10
19  6  1  2 11
18  5  4  3 12
17 16 15 14 13

It can be verified that the sum of the numbers on the diagonals is 101.

What is the sum of the numbers on the diagonals in a 1001 by 1001 spiral formed in the same way?

linksoben->rechtsunten
>>> summe = []
>>> dazu = 2
>>> zahl = 1
>>> while True:
...     summe.append(zahl)
...     if len(summe) == 5:
...         break
...     zahl += dazu
...     dazu += 2
... 
>>> summe
[1, 3, 7, 13, 21]
>>>

Gesetzmaessigkeit rechtsoben-linksunten
>>> print ('1 5 9 17 25')
1 5 9 17 25
>>> summe = []
>>> zahl = 1
>>> dazu = 4
>>> count = 0
>>> while True:
...     summe.append(zahl)
...     if len(summe) == 5:
...            break
...     zahl += dazu
...     count += 1
...     if not count % 2:
...         dazu += 4
... 
>>> 
>>> summe
[1, 5, 9, 17, 25]
>>>
'''
# Copyright (c) 2013 michael poeltl
# This program or module is free software: you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published
# by the Free Software Foundation, version 2.0 of the License
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
# It is provided for educational
# purposes and is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.

__author__ = 'michael poeltl'
__version__ = '0.01'
__license__ = 'GPLv2.0'
__email__ = 'michael.poeltl@univie.ac.at'
__copyright__ = 'poeltl (c) 2013'
#start

import sys

def lioreu(biszu=5):
    '''Diagonlae von links oben nach rechts unten'''
    dazu = 2
    summe = []
    zahl = 1
    while True:
        summe.append(zahl)
        if len(summe) == biszu:
            return sum(summe)
        zahl += dazu
        dazu += 2

def reoliu(biszu=5):
    '''diagonale rechts oben links unten'''
    summe = []
    zahl = 1
    dazu = 4
    count = 0
    while True:
        summe.append(zahl)
        if len(summe) == biszu:
            return sum(summe)
        zahl += dazu
        count += 1
        if not count % 2:
            dazu += 4

def main():
    umlaeufe = eval(sys.argv[1])
    linksoben = lioreu(umlaeufe)
    rechtsoben = reoliu(umlaeufe)
    print ('Summe ist {} + {} - 1 = {}'.format(linksoben,rechtsoben,linksoben+rechtsoben-1))

if __name__ == '__main__':
    main()
