#! /usr/bin/env python3

'''
siehe:
http://projecteuler.net/problem=3

The prime factors of 13195 are 5, 7, 13 and 29.

What is the largest prime factor of the number 600851475143 ?

JEDE natuerliche Zahl ausser 0,1 oder einer Primzahl laesst sich in ihre Primfaktoren zerlegen.
'''
from math import ceil

__author__ = 'michael poeltl'
__version__ = '0.01'
__license__ = 'GPLv2'

def isprim(n):                                                                 
    '''
    is n a prime-number?
    SYNTAX: isprim(integer)
    ret-val is True|False
    '''
    if n < 2:
        return False
    if n in (2,3,5,7,11,13,17,19,23,29):
        return True
    elif n % 2 == 0:
        return False
    for i in range(3,ceil(n**0.5)+10,2):
        if n % i == 0:
            return False
    return True

def main():
    while True:
        try:
            ZAHL = zahl = eval(input("Zahl, die in ihre prim-Faktoren zerlegt werden soll? "))
            if isinstance(zahl,int) and zahl>1:
                break
        except:
            continue
    primfaktoren = []
    while zahl >1:
        if zahl > 2 and zahl % 2 == 0:
            primfaktoren.append(2)
            zahl //=2
        #elif zahl in [2,3,5,7,11,13]:
            #primfaktoren.append(zahl)
            #break
        elif isprim(zahl) == True:
            print ('zahl {}'.format(zahl))
            primfaktoren.append(zahl)
            break
        else:
            bereich = ceil(zahl**0.5) if zahl > 20000000 else ceil(zahl//2)
            for i in range(3,bereich,2):
                if isprim(i) and zahl%i == 0:
                    if i == zahl:
                        primfaktoren.append(zahl)
                        zahl = 1
                        break
                    else:
                        zahl //=i
                        primfaktoren.append(i)
                        break
    primfaktoren.sort()
    print ("Der groesste Primfaktor der Zahl {} ist {}".format(ZAHL,primfaktoren[-1]))
    print ("Kontrolle:")
    print ("primfaktoren sind: {}".format(primfaktoren))

if __name__ == '__main__':
    main()
