#! /usr/bin/env python3
# -*- coding: utf-8 -*-
'''
We shall say that an n-digit number is pandigital if it makes use of all the digits 1 to n exactly once; for example, the 5-digit number, 15234, is 1 through 5 pandigital.

The product 7254 is unusual, as the identity, 39 * 186 = 7254, containing multiplicand, multiplier, and product is 1 through 9 pandigital.

Find the sum of all products whose multiplicand/multiplier/product identity can be written as a 1 through 9 pandigital.

HINT: Some products can be obtained in more than one way so be sure to only include it once in your sum.

Sh> #ergebnis version 0.01 OHNE itertools
Sh> time python3 euler_project_32.py
die summe aller "1 through 9 pandigital products" ist 45228

real    0m14.582s
user    0m14.561s
sys     0m0.020s
Sh> #Ergebnis MIT itertools
Sh> time python3 euler_project_32_v002.py 
die summe aller "1 through 9 pandigital products" ist 45228

real    0m0.698s
user    0m0.692s
sys 0m0.008s
?> 
'''
# Copyright (c) 2013 michael poeltl
# This program or module is free software: you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published
# by the Free Software Foundation, version 2.0 of the License
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
# It is provided for educational
# purposes and is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.

#correct answer is 45228
# moechte die richtige Antwort festhalten bevor ich meinen code verschoenere

__author__ = 'michael poeltl'
__version__ = '0.02'
__license__ = 'GPLv2.0'
__email__ = 'michael.poeltl@univie.ac.at'
__copyright__ = 'poeltl (c) 2013'

import itertools
import string

def get_summe(sammlungaller=[]):
    passt = []
    for i in sammlungaller:
        i = ''.join(i)
        ergebnis = int(i[5:])
        if int(i[:2]) * int(i[2:5]) == ergebnis:
            passt.append( ergebnis )
        elif int(i[0])*int(i[1:5]) == ergebnis:
            passt.append( ergebnis )
    return sum( set( passt ) )

def main():
    satzneun = itertools.permutations( string.digits[1:] )
    print ('die summe aller "1 through 9 pandigital products" is {}'.format( get_summe( satzneun ) ))

if __name__ == '__main__':
    main()
