#! /usr/bin/env python3
# -*- coding: utf-8 -*-
'''
The fraction 49/98 is a curious fraction, as an inexperienced mathematician in attempting to simplify it may incorrectly believe that 49/98 = 4/8, which is correct, is obtained by cancelling the 9s.

We shall consider fractions like, 30/50 = 3/5, to be trivial examples.

There are exactly four non-trivial examples of this type of fraction, less than one in value, and containing two digits in the numerator and denominator.

If the product of these four fractions is given in its lowest common terms, find the value of the denominator.
'''
# Copyright (c) 2013 michael poeltl
# This program or module is free software: you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published
# by the Free Software Foundation, version 2.0 of the License
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
# It is provided for educational
# purposes and is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.

__author__ = 'michael poeltl'
__version__ = '0.01'
__license__ = 'GPLv2.0'
__email__ = 'michael.poeltl@univie.ac.at'
__copyright__ = 'poeltl (c) 2013'

def main():
    start = 100
    treffer = []
    while start >10:
        start -= 1
        runner = 11
        for i in range(runner,start):
            if str(i)[1] == str(start)[0]:
                try:
                    if int( str(i)[0] ) / int( str(start)[1] ) == i/start:
                        treffer.append( (i,start) )
                except ZeroDivisionError:
                    pass
    print (treffer)
    nenner = 1
    zaehler =1
    for z,n in treffer:
        zaehler *= z
        nenner  *= n
    for i in range(1,10):
        if zaehler % i == 0:
            zaehler //= i
            if nenner % zaehler == 0:
                print ('Der nenner des zusammengekuerzten Bruches ist {}'.format( nenner//zaehler ) )
                break
                    

if __name__ == '__main__':
    main()
