#! /usr/bin/env python3
# -*- coding: utf-8 -*-
'''
Problem 35
The number, 197, is called a circular prime because all rotations of the digits: 197, 971, and 719, are themselves prime.

There are thirteen such primes below 100: 2, 3, 5, 7, 11, 13, 17, 31, 37, 71, 73, 79, and 97.

How many circular primes are there below one million?

VORSICHT! Rotation und NICHT Permutation!!

Sh> time python3 euler_project_35.py
Anzahl primes: 1113
['199933', '93719', '19937', '3', '2', '311', '5', '319993', '719', '9311', '197', '93911', '193939', '1931', '199', '933199', '999331', '3119', '1193', '99371', '39119', '7793', '331999', '3779', '919', '939193', '79', '71993', '11939', '13', '17', '11', '71', '73', '971', '733', '393919', '37199', '113', '993319', '131', '9377', '7937', '97', '337', '373', '31', '391939', '19391', '37', '91193', '7', '991', '939391', '919393']
Anzahl: 55

real    0m4.241s
user    0m4.240s
sys     0m0.000s
Sh>
'''
# Copyright (c) 2013 michael poeltl
# This program or module is free software: you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published
# by the Free Software Foundation, version 2.0 of the License
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
# It is provided for educational
# purposes and is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.

__author__ = 'michael poeltl'
__version__ = '0.02'
__license__ = 'GPLv2.0'
__email__ = 'michael.poeltl@univie.ac.at'
__copyright__ = 'poeltl (c) 2013'

from euler_project_7 import isprim

def get_needed_prims( bereich ) -> list:
    prim_pool = []
    for i in range( 1,bereich ):
        if isprim(i):
            if i < 10:
                prim_pool.append( i )
            else:
                for c in str(i):
                    if c in [ '0', '2', '4', '5', '6', '8' ]:
                        break
                else:
                    prim_pool.append( i )
    return prim_pool

def get_rotated( n ) -> list:
    if n < 10:
        return [ str(n) ]
    rotated = []
    szahl = list( str( n ) )
    rotated.append( str(n) )
    for ticker in range( len( szahl ) -1 ):
        szahl.append( szahl.pop( 0 ) )
        rotated.append( ''.join( szahl ))
    return rotated

def main():
    needed_prims = get_needed_prims( 1000000 )
    treffer = []
    rotated = []
    print ('Anzahl primes: {}'.format( len( needed_prims ) ) )
    for zahl in needed_prims[:]:
        rotated = get_rotated( zahl )
        for i in rotated:
            if int( i ) not in needed_prims:
                break
        else:
            treffer.extend( rotated )
    treffer = list( set( treffer ) )
    print (sorted( treffer ))
    print ('Anzahl: {}'.format( len( treffer ) ))


if __name__ == '__main__':
    main()
