#! /usr/bin/env python3
# -*- coding: utf-8 -*-
'''
Problem 35
The number, 197, is called a circular prime because all rotations of the digits: 197, 971, and 719, are themselves prime.

There are thirteen such primes below 100: 2, 3, 5, 7, 11, 13, 17, 31, 37, 71, 73, 79, and 97.

How many circular primes are there below one million?

h> time python3 euler_project_35.py 
TREFFER: [991, 199, 919]
TREFFER: [919, 991, 199]
TREFFER: [733, 373, 337]
TREFFER: [373, 337, 733]
TREFFER: [337, 373, 733]
TREFFER: [311, 131, 113]
TREFFER: [199, 991, 919]
TREFFER: [131, 311, 113]
TREFFER: [113, 131, 311]
laenge treffer_mit moeglichen doppelten: 40
keine doppelte in Treffer, Laenge = 22

real    0m0.688s
user    0m0.688s
sys     0m0.000s
Sh>
Sh>

Vorsicht! lt. projecteuler ist 22 das FALSCHE Ergebnis!!! ich hab aber noch kein besseres ;-)
findest du meinen Fehler?
'''
# Copyright (c) 2013 michael poeltl
# This program or module is free software: you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published
# by the Free Software Foundation, version 2.0 of the License
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
# It is provided for educational
# purposes and is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.

__author__ = 'michael poeltl'
__version__ = '0.01'
__license__ = 'GPLv2.0'
__email__ = 'michael.poeltl@univie.ac.at'
__copyright__ = 'poeltl (c) 2013'

from string import digits
from random import shuffle
from math import factorial
from euler_project_7 import isprim

def get_permutation(n):
    szahl = str(n)
    maxperm = factorial(len(szahl))
    indizes = list(digits[:len(szahl)])
    perm_indizes = [ indizes[:], ]
    end_list = [n,]
    while len(perm_indizes) < maxperm:
        shuffle( indizes )
        if indizes not in perm_indizes:
            perm_indizes.append(indizes[:])
            zahl = int( ''.join([ szahl[int(i)] for i in indizes ]) )
            if isprim( zahl ):
                if zahl not in end_list:
                    end_list.append( zahl )
            else:
                return False
    return end_list

def main():
    treffer = [ 2, 3, 5, 7, 11, 13, 17, 31, 37, 71, 73, 79, 97 ]
    for tocheck in range(999997, 100, -2):
        #  zahlen, die mit 0,2,4,6,8,5 enden oder durch 3 oder 7 teilbar sind
        #+ sind keine primzahlen 9eh klar
        #+ da aber so eine Zahl entstehen kann beim variieren der Ziffern einer Zahl
        #+ kann ich die schon mal vorausfiltern
        isdrin = False
        for c in str(tocheck):
            if c in ('0','2','4','5','6','8'):
                isdrin = True
        else:
            if isdrin:
                continue
        if tocheck % 3 == 0 or tocheck % 5 == 0 or tocheck % 7 == 0:
            continue
        primmenge = get_permutation( tocheck )
        if primmenge:
            print ('TREFFER: {}'.format( primmenge, ))
            treffer.extend(primmenge)
    print ('laenge treffer_mit moeglichen doppelten: {}'.format(len(treffer)))
    print ('keine doppelte in Treffer, Laenge = {}'.format(len( list( set(treffer) ) ) ) )

if __name__ == '__main__':
    main()
