#! /usr/bin/env python3

'''
Special Pythagorean triplet
Problem 9
A Pythagorean triplet is a set of three natural numbers, a  b  c, for which,

a2 + b2 = c2
For example, 32 + 42 = 9 + 16 = 25 = 52.

There exists exactly one Pythagorean triplet for which a + b + c = 1000.
Find the product abc.

S> python3 ~/work/uniweb/py/bsp/euler_project_9.py
200 375 425
Das Ergebnis lautt 31875000
S>

es gibt sicher eine viel elegantere Methode - z.B. koennt man das nur ueber a,b loesen

a^2 + b^2 == c^2
a+b+c == 1000
c == (a^2+b^2)**0.5

a+b+(a^2+b^2)**0.5 == 1000
'''

__author__ = 'michael poeltl'
__version__ = '0.01'
__license__ = 'GPLv2'


def is_pyth(a,b,c):
    if a**2+b**2 == c**2:
        return True
    else:
        return False


def main():
#pythagorean triplet
#    a<b<c
    a,b,c = 1,2,3
    fertig = False
    for a in range(2,300):
        if fertig:
            break
        for b in range(a+1,400):
            for c in range(a+2,500):
                if a+b+c==1000 and is_pyth(a,b,c):
                    print (a,b,c)
                    print ("Das Ergebnis lautt {}".format(a*b*c))
                    fertig = True


if __name__ =='__main__':
    main()
