#! /opt/bin/python3

'''
einfache Bewegung
Diagonal - erster Einsatz von Vektoren
'''

from math import floor
import pygame
from mygeometry import Vector2d

FPS = 30
SCREEN = (800,600)
BLACK = (0,0,0)
WHITE = (255,255,255)
RADIUS = 30

pygame.init()

screen = pygame.display.set_mode(SCREEN, 0, 32)
pygame.display.set_caption("go diagonal")
clock = pygame.time.Clock()

punkt0 = Vector2d(0,0)
position = Vector2d(100,100)
speed = 250#pixel per second
while True:
    ms = clock.tick( FPS )
    seconds = s = ms/1000
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            raise SystemExit()
        if event.type == pygame.KEYDOWN:
            if event.key in (pygame.K_q, pygame.K_ESCAPE):
                pygame.quit()
                raise SystemExit()
        if event.type == pygame.MOUSEBUTTONDOWN:
            print(position)
            x,y = pygame.mouse.get_pos()
            destination = Vector2d(x,y) - Vector2d(RADIUS,RADIUS)
            punkt0 = Vector2d.twopoints(position.get_pos(), destination.get_pos())
            punkt0.normalize()
        if event.type == pygame.MOUSEBUTTONUP:
            punkt0 = Vector2d()
            position = Vector2d(100,100)
    v = speed * s
    punkt0 *= v
    position += punkt0
    x,y = int(position.x),int(position.y)
    if x > 800:
        x -= 800
        speed = -speed
    elif x < 0:
        x = 0
    if y > 600:
        y -= 600
        speed = -speed
    elif y < 0:
        y = 0
    screen.lock()
    screen.fill(BLACK)
    pygame.draw.circle(screen,WHITE,(x,y),30)
    screen.unlock()
    pygame.display.flip()
