#! /opt/bin/python3

'''
lerp ist ein interner Ausdruck fuer
linear interpolation
und wird verwendet, um eine Farbe in eine andere
langsam zu veraendern
'''
import pygame

pygame.init()

screen = pygame.display.set_mode( (800,600), 0, 32)
pygame.display.set_caption(" linear interpolation ")

#farbe1 langsam live in farbe2 wechseln
farbe1 = (221,101,27)
farbe2 = (96,120,40)

faktor = 0
punkte = [ (0,125), (639,111), (700,300) ]#fuer polygon

def blend_color( color1, color2, factor ):
    rot1,gruen1,blau1 = color1
    rot2,gruen2,blau2 = color2

    rot = rot1 + (rot2 - rot1) * factor
    gruen = gruen1 + (gruen2 - gruen1) * factor
    blau = blau1 + (blau2 - blau1) * factor
    return ( int(rot), int(gruen), int(blau), )

while True:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            raise SystemExit()
        if event.type == pygame.KEYDOWN:
            if event.key == pygame.K_q:
                pygame.quit()
                raise SystemExit()
    screen.fill( (255,255,255) ) 
    screen.lock()
    pygame.draw.polygon( screen, ( 0,255,0 ), punkte)
    pygame.draw.circle( screen, (0,0,0), (int( faktor* 639), 120), 10)
    screen.unlock()
    x,y = pygame.mouse.get_pos()
    if pygame.mouse.get_pressed()[0]:
        faktor = x/639
    farbe = blend_color(farbe1, farbe2, faktor)
    pygame.display.set_caption("faktor ist {:.3f}".format(faktor))
    screen.lock()
    pygame.draw.rect(screen, farbe, pygame.Rect(0,340, 400,150))
    screen.unlock()
    pygame.display.flip()
