#! /opt/bin/python3

'''
pygame intro
drawing rectangel using Rect-class
'''
import pygame

BLACK = pygame.Color('black')
PURPLE = pygame.Color('purple')
WIDTH = 800
HEIGHT = 600
FPS = 30

#startpos of block
blockwidth = 50
blockheight = 100
#topleft edge
blockx = WIDTH//2 - blockwidth//2
blocky = HEIGHT//2 - blockheight//2
block = pygame.Rect(blockx, blocky, blockwidth, blockheight)

pygame.init()

screen = pygame.display.set_mode( (WIDTH,HEIGHT), 0, 32)
pygame.display.set_caption("simple movement")

speed= 200
clock = pygame.time.Clock()

while True:
    ms = milliseconds = clock.tick( FPS )
    s  = seconds = ms/1000
    block.top += speed*s
    if block.top <0:
        speed = -speed
    elif block.bottom > HEIGHT:
        speed = -speed
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            raise SystemExit()
        if event.type == pygame.KEYDOWN:
            if event.key in (pygame.K_q, pygame.K_ESCAPE):
                pygame.quit()
                raise SystemExit()
    screen.lock()
    screen.fill(BLACK)
    pygame.draw.rect( screen, PURPLE, block)
    screen.unlock()
    pygame.display.flip()
