#! /usr/bin/env python3

'''
Wir lassen einen Ball von links nach rechts sausen, mit einer gewissen
Geschwindigkeit; mit Pfeil-UP wird der speed erhoeht,
Pfeil-down reduziert den speed
ein speed vn 0 laesst den Ball in der Luft tehen,
ein minus-Speed bewegt den Ball von rechts nach links
'''

import pygame
from math import floor

FPS = 30
SCREEN = (800,600)
WHITE = ( 255,255,255 )

pygame.init()
screen = pygame.display.set_mode( SCREEN, 0, 32 )

clock = pygame.time.Clock()
speed = 100#pixel/s at start
x = 0#startposition

while True:
    ms = clock.tick( FPS )
    seconds = ms/1000
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            raise SystemExit()
        if event.type == pygame.KEYDOWN:
            if event.key in (pygame.K_q, pygame.K_ESCAPE):
                pygame.quit()
                raise SystemExit()
            if event.key == pygame.K_DOWN:
                speed -= 10
            if event.key == pygame.K_UP:
                speed += 10
    x += speed*seconds
    if x > screen.get_width():
        x -= screen.get_width()
    elif x < 0:
        x += screen.get_width()+1

    screen.lock()
    screen.fill( (0,0,0) )
    pygame.draw.circle( screen, WHITE, (floor(x),200), 15,0)
    pygame.display.set_caption( 'SPEED: {} pixels/second'.format( speed ))
    screen.unlock()
    pygame.display.flip()

