#! /opt/bin/python3

'''
dies ist eine Kontrolle der Zeit in pygame
ich hole mir einerseits die Zeit (Sekunden) vom perf_counter()
und via pygame.time.Clock()
und paste die vergehenden Sekunden in die Titelleiste des 
Fensters - man sieht, dass die Zeit verlaesslich im Sek-Takt ablaeuft

in pygame ist die Zeit in millisekunden
daher muss man die Ausgabe in ms noch durch 1000 dividieren
um den Sekundenwert zu bekommen
'''
import time
import pygame

pygame.init()
clock = pygame.time.Clock()
screen = pygame.display.set_mode( (800,600),0,32)
pygamezeit = 0
p = time.perf_counter()

while True:
    ms = clock.tick(30) #musste die framerate auf 30 setzen, sonst
                        #friert bei mir das display ein
                        #verhalten aendert sich nicht bei groesserer FR
    seconds = ms/1000
    t2 = time.perf_counter()
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            raise SystemExit()
        if event.type == pygame.KEYDOWN:
            if event.key in (pygame.K_q, pygame.K_ESCAPE):
                pygame.quit()
                raise SystemExit()
    pygamezeit += seconds
    screen.lock()
    t = t2 - p
    pygame.display.set_caption('{:.0f}\t{:.0f}'.format(pygamezeit,t))
    screen.unlock()
    pygame.display.update()
