#! /opt/bin/python3

'''
eine Linie mit der Laenge von 100pixel soll sich 
von links nach rechts durchs Fenster
bewegen
und zwar so schnell, dass es in 8Sekunden den rechten Rand erreicht
die Linie wird also mit 100pixel/Sekunde vorangeschoben

die pygamezeit wird auf 0 zurueckgesetzt, sobald
der rechte Rand erreicht wird
waehrend die verstrichene Zeit weiterlaeuft
'''
import time
import pygame

pygame.init()
clock = pygame.time.Clock()
screen = pygame.display.set_mode( (800,600),0,32)
pygamezeit = 0
p = time.perf_counter()
speed = 100#  pixel (soviele pixel pro Sekunde)
           #+ doch die umrechnung in pixel/sec erfolgt
           #+ weiter unten
x = 0
while True:
    ms = clock.tick(60) 
    seconds = ms/1000
    t2 = time.perf_counter()
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            raise SystemExit()
        if event.type == pygame.KEYDOWN:
            if event.key in (pygame.K_q, pygame.K_ESCAPE):
                pygame.quit()
                raise SystemExit()
    pygamezeit += seconds
    screen.lock()
    screen.fill((0,0,0))#for the illusion of movement
    t = t2 - p
    x += speed*seconds#  in EINER Sek bewegt sich die Linie
                      #+ dann um speed-PIXEL weiter
    if x > 800:
        x -= 800
        pygamezeit = 0#reset
    pygame.display.set_caption('{:.0f}\t{:.0f}'.format(pygamezeit,t))
    pygame.draw.line( screen, (255,255,255),(x-100,100),(x,100),3)
    screen.unlock()
    pygame.display.update()
