#! /opt/bin/python3

import math
import time
import pygame
BLACK = pygame.Color('black')
WHITE = pygame.Color('white')
FPS = 30

pygame.init()
screen = pygame.display.set_mode( (800,600), 0, 32)

speedh = 100
speedw = 100
speedx = 100
speedy = 100

start = 0
end = math.pi/4

x = 200
y = 200
w = 150
h = 150

clock = pygame.time.Clock()
while True:
    ms = clock.tick(FPS)
    s = ms/1000
    x += speedx*s
    y += speedy*s
    w += speedw*s
    h += speedh*s

    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            raise SystemExit()
        if event.type == pygame.KEYDOWN:
            if event.key in (pygame.K_q, pygame.K_ESCAPE):
                pygame.quit()
                raise SystemExit()
    screen.fill(BLACK)
    screen.lock()
    pygame.draw.arc( screen, WHITE, (x,y, w, h), start, end, 2)
    pygame.draw.rect(screen,WHITE,pygame.Rect(x,y, w, h),1)
    pygame.draw.circle(screen,WHITE,(int(x)+int(w/2),int(y)+int(h/2)),2,2)
    screen.unlock()
    start,end = end,start+speedx*s+math.pi/4
    if x > 250:
        speedx = -speedx
        x = 250
    elif x < 100:
        speedx = -speedx
        x = 100
    if y > 250:
        speedy = -speedy
        y = 250
    elif y < 100:
        y = 100
        speedy = -speedy
    if w < 100:
        speedw = -speedw
        w = 100
    elif w > 250:
        speedw = -speedw
        w = 250
    if h < 100:
        speedh = -speedh
        h = 100
    elif h > 250:
        speedh = -speedh
        h = 250
    pygame.display.flip()
