#! /opt/bin/python3

'''
from youtube:
pygame physics tutorial 3

factors and motion
'''
import math
import random
import sys
import pygame
import euclid #  euclid.py from
              #+ http://code.google.com/p/p/pyeuclid/
              #+ 2to3 -W euclid.py



#some colors first
black = (0,0,0)
white = (255,255,255)
red = (255,0,0)
green = (0,255,0)
blue = (0,0,255)

colors = (black, red, blue, green,)

initial_velocity = 20

class MyCircle:
    def __init__(self,
                 position,
                 size,
                 color = (255,255,255,),
                 velocity = euclid.Vector2(0,0),
                 width=1
                ):
        self.position = position
        self.size = size
        self.color = color
        self.velocity = velocity
        self.width = width
    def display(self):
        rx,ry = int( self.position.x), int( self.position.y )
        pygame.draw.circle( screen, self.color, (rx,ry,),self.size,self.width)

    def move(self):
        self.position += self.velocity * dtime

    def change_velocity(self, velocity):
        self.velocity = velocity

def get_random_velocity():
    new_angle = random.uniform(0, math.pi*2)
    new_x = math.sin( new_angle )
    new_y = math.cos( new_angle )
    new_vector = euclid.Vector2( new_x, new_y)
    new_vector.normalize()
    new_vector *= initial_velocity #pixels per second
    return new_vector

number_of_colors = 10
my_circles = list()

screen_size = screen_width, screen_height = (800, 600,)
screen = pygame.display.set_mode(screen_size, 0, 32)
pygame.display.set_caption("first class")

for n in range(number_of_colors):
    size = random.randint(10,20) #radius
    x = random.randint( size, screen_width - size )
    y = random.randint( size, screen_height - size )
    color = random.choice( colors )
    velocity = get_random_velocity()
    my_circles.append(MyCircle(euclid.Vector2(x,y), size, color))

direction_tick = 0.0

clock = pygame.time.Clock()
fps_limit = 60

running = True

while running:
    #limit framrate
    dtime_ms = clock.tick( fps_limit )
    dtime = dtime_ms / 1000

    direction_tick += dtime
    if direction_tick > 1.0:
        direction_tick = 0
        random_circle = random.choice( my_circles )
        new_velocity = get_random_velocity()
        random_circle.change_velocity( new_velocity )
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            running = False
        if event.type == pygame.KEYDOWN:
            if event.key == pygame.K_q:
                running = False
    screen.lock()
    #clear screen
    screen.fill( white )

    for my_circle in my_circles:
        my_circle.move()
        my_circle.display()
    screen.unlock()
    pygame.display.flip()
#quit the game
pygame.quit()
sys.exit()

