#! /usr/bin/env python3

import pygame

FPS = 60
SCREEN = (800,600)
WHITE = ( 255,255,255 )
LENGTH = 100#pixellength of line

pygame.init()
screen = pygame.display.set_mode( SCREEN, 0, 32 )

clock = pygame.time.Clock()
speed = 100#pixel/s
x = 0

fadex = False
while True:
    ms = clock.tick( FPS )
    seconds = ms/1000
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            raise SystemExit()
        if event.type == pygame.KEYDOWN:
            if event.key in (pygame.K_q, pygame.K_ESCAPE):
                pygame.quit()
                raise SystemExit()
            if event.key == pygame.K_DOWN:
                speed -= 10
            if event.key == pygame.K_UP:
                speed += 10
    x += speed*seconds
    if x > 800:
        x -= 800
        fadex = True
    elif x < 0:
        x += 801

    screen.lock()
    screen.fill( (0,0,0) )
    pygame.draw.line( screen, WHITE, (x-LENGTH,200), (x,200),3)
    if fadex:
        pygame.draw.line( screen, WHITE, (750,200), (800,200),3)
        fadex = False
    pygame.display.set_caption( 'SPEED: {} pixels/second'.format( speed ))
    screen.unlock()
    pygame.display.flip()

