#! /opt/bin/python3

'''
Idea from stephen wolfram
https://www.youtube.com/watch?v=_eC14GonZnU

continue wolfram1.py - a slightly different ruleset
and smaller cells

a cell is white if all of its neighbors above is white OR
all of its neighbours above are black
otherwise it is black

for this we need to define a first row
then we build a field
and finally the graphics

I did it the easy way (could be shorter but more complex t understand the lines
'''

__author__ = 'michael poeltl'
__date__ = '07152014'
 
import pygame

WHITE = pygame.Color('white')
BLACK = pygame.Color('black')
COLOR = {'w':WHITE, 'b':BLACK}
columns = 83
rows = 41
field = dict()
#starting point
#take care with round round(2.5) -> 2
field[0] = [ 'w' if x% ( round( columns/2)+1 ) else 'b'  for x in range(1,columns+1)]
for row in range(1,rows+1):
    l = field[row-1]
    newl = list()
    for i in range( len(l) ):
        if i is 0:
            if l[1] is 'b':
                newl.append('b')
            else:
                newl.append('w')
        elif i is len(l)-1:
            if l[-2] is 'b':
                newl.append('b')
            else:
                newl.append('w')
        else:
            if l[i] is 'w' and l[i-1] is 'w' and l[i+1] is 'w':
                newl.append('w')
            elif l[i] is 'b':
                newl.append('w')
            else:
                newl.append('b')
    field[row] = newl
cubeside = cs = 10#pixel
width = columns * cs
height = rows * cs
screen = pygame.display.set_mode( (width,height),0,8 )
for y in field:
    for x,color in enumerate(field[y]):
        quad = pygame.Rect(x*cs, y*cs, cs, cs)
        screen.fill(COLOR[color],quad)
pygame.display.flip()
while True:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            raise SystemExit()
        if event.type == pygame.KEYDOWN:
            if event.key in (pygame.K_q, pygame.K_ESCAPE):
                pygame.quit()
                raise SystemExit()


