#! /opt/bin/python3

'''
Idea from stephen wolfram
https://www.youtube.com/watch?v=_eC14GonZnU
a cell is white if all of its neighbors above is white
otherwise it is black

for this we need to define a first row
then we build a field
and finally the graphics

I did it the easy way (could be shorter but more complex t understand the lines
'''

__author__ = 'michael poeltl'
__date__ = '07152014'
 
import pygame

WHITE = pygame.Color('white')
BLACK = pygame.Color('black')
COLOR = {'w':WHITE, 'b':BLACK}
#field = {0:['w','w','w','w','w','w','w','w','w','w','b','w','w','w','w','w','w','w','w','w','w'}
field = dict()
#starting point
field[0] = [ 'w' if x%11 else 'b'  for x in range(1,22)]
for row in range(1,10):
    l = field[row-1]
    newl = list()
    for i in range( len(l) ):
        if i is 0:
            if l[0] == 'w' and l[1] == 'w':
                newl.append('w')
            else:
                newl.append('b')
        elif i == len(l)-1:
            if l[-1] == 'w' and l[-2] == 'w':
                newl.append('w')
            else:
                newl.append('b')
        else:
            if l[i] == 'w' and l[i-1] == 'w' and l[i+1] == 'w':
                newl.append('w')
            else:
                newl.append('b')
    field[row] = newl
cubeside = cs = 25
width = 21*cs
height = 9*cs
screen = pygame.display.set_mode( (width,height),0,8 )
for y in field:
    for x,color in enumerate(field[y]):
        pygame.draw.line(screen, BLACK, (0,y*cs), (len(field[0])*cs,y*cs),1)
        pygame.draw.line(screen, BLACK, (x*cs,0), (x*cs,len(field)*cs),1)
        quad = pygame.Rect(x*cs, y*cs, cs, cs)
        screen.fill(COLOR[color],quad)
pygame.display.flip()
while True:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            raise SystemExit()
        if event.type == pygame.KEYDOWN:
            if event.key in (pygame.K_q, pygame.K_ESCAPE):
                pygame.quit()
                raise SystemExit()


