#! /opt/bin/python3

'''
Idea from stephen wolfram
https://www.youtube.com/watch?v=_eC14GonZnU

continue wolfram1.py - a slightly different ruleset

a cell is black, if the cell up-right is black AND if there was no other cell
black left to it
the cell up-left is black AND there was no cell black right to it
otherwise the (new) cell is white

for this we need to define again a first row
then we build a field
and finally the graphics

I did it the easy way (could be shorter but maybe more complex
to understand the lines easily
'''

__author__ = 'michael poeltl'
__date__ = '07152014'
 
import pygame

WHITE = pygame.Color('white')
BLACK = pygame.Color('black')
COLOR = {'w':WHITE, 'b':BLACK}
#field = {0:['w','w','w','w','w','w','w','w','w','w','b','w','w','w','w','w','w','w','w','w','w'}
field = dict()
#starting point
field[0] = [ 'w' if x%11 else 'b'  for x in range(1,22)]
for row in range(1,10):
    l = field[row-1]
    newl = list()
    for i in range( len(l) ):
        if i is 0:
            if l[1] is 'b':
                newl.append('b')
            else:
                newl.append('w')
        elif i is len(l)-1:
            if l[-2] is 'b':
                newl.append('b')
            else:
                newl.append('w')
        else:
            if l[i+1] is 'b' and 'b' not in l[:i]:
                newl.append('b')
            elif l[i-1] is 'b' and 'b' not in l[i:]:
                newl.append('b')
            else:
                newl.append('w')

    field[row] = newl
cubeside = cs = 25
width = 21*cs
height = 9*cs
screen = pygame.display.set_mode( (width,height),0,8 )
for y in field:
    for x,color in enumerate(field[y]):
        quad = pygame.Rect(x*cs, y*cs, cs, cs)
        screen.fill(COLOR[color],quad)
pygame.display.flip()
while True:
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            raise SystemExit()
        if event.type == pygame.KEYDOWN:
            if event.key in (pygame.K_q, pygame.K_ESCAPE):
                pygame.quit()
                raise SystemExit()


