#! /usr/bin/env python3

from turtle import *
from random import randint,shuffle
from math import floor

__author__ = 'michael poeltl'
__version__ = '0.01'
__copyright__ = 'poeltl (c) 2013'
__license__ = 'GPLv2'

def getfarbe():
    '''Farbe in rgb'''
    _r = randint(0,255)
    _g = randint(0,255)
    _b = randint(0,255)
    r = hex(_r)[2:] if len(hex(_r)) == 4 else '0'+hex(_r)[2:]
    g = hex(_g)[2:] if len(hex(_g)) == 4 else '0'+hex(_g)[2:]
    b = hex(_b)[2:] if len(hex(_b)) == 4 else '0'+hex(_b)[2:]
    return '#'+r+g+b

def punkterl(farbe,x,y):
    color(farbe)
    goto(x,y)
    down()
    circle(0.5)
    up()
    return None

def main():
    #mode setzen auf logo (fuer alle faelle)
    mode(mode='standard')
    #fenster 80% von Bildschirmhoehe/breite zentriert
    setup(width=.20, height=.20, startx=None, starty=None)
    maxpixel=window_height()*window_width()
    print (maxpixel)
    fenster = Screen()
    fenster.title('es regnet Punkte')
    up()
    speed('fastest')
    ht()
    X = floor(window_width()/2)
    Y = floor(window_height()/2)
    alle_punkte = []
    for x in range(X):
        for y in range(Y):
            alle_punkte.append((x,y))
            alle_punkte.append((x*-1,y))
            alle_punkte.append((x,y*-1))
            alle_punkte.append((x*-1,y*-1))
    gesammelte_punkte = len(alle_punkte)
    count = 0
    maxpunkte = window_width()/2 * window_height()/2
    while alle_punkte:
        shuffle(alle_punkte)
        farbe = getfarbe()
        pnext = alle_punkte.pop()
        punkterl(farbe,pnext[0],pnext[1])
        count += 1
        if not count%10000:
            print ('momentan {} Punkte'.format(count-1))
        
    print ("gezaehlt: {}".format(count))
    print ('in liste: {}'.format(gesammelte_punkte))
    print ('max moegliche punkte: {}'.format(maxpunkte))

    fenster.onkey(bye,'q')
    fenster.listen()
    fenster.mainloop()

if __name__ == '__main__':
    main()

