#! /usr/bin/env python3
'''
Versuch einer Spirale,
sodass die Radien rn und rn+1 rn+2... die fibonacci-Folge durchgehen
'''

import turtle
from turtle import bye
from random import shuffle

def get_fibo():
    '''
    Fibonacci-Folge
    1 1 2 3...
    '''
    a,b = 0,1
    while True:
        a,b = b,a+b
        yield a

def main():
    farben = ['black','red','blue','orange', 'green']
    durchlaeufe = 3
    turtle.reset()
    turtle.ht() #hide turtle --> ht()
    turtle.setup(2400,1200)
    fenster = turtle.Screen()
    fenster.title('goldener Schnitt')
    turtle.pensize(3)
    fibo = get_fibo()
    step = next( fibo )
    #farbe = ['black','red','green','blue','orange','yellow','violet','cyan']
    fenster.onkey( bye, 'q' )
    turtle.pencolor(farben[0])
    turtle.circle( step, 180)
    for durchlauf in range(durchlaeufe):
        shuffle(farben)
        for i in range( len(farben) ):
            step = next( fibo )
            turtle.pencolor(farben[i])
            turtle.circle( step, 180)
    fenster.listen()
    fenster.mainloop()

if __name__ == '__main__':
    main()
