#! /usr/bin/env python3
'''
Versuch einer Spirale,
sodass die Radien rn und rn+1 (rn < rn+1) im Verhaelntis
des Goldenen Schnitts stehen
'''

import turtle
from turtle import bye
from random import shuffle

def get_grossgold( klein ):
    '''
    ermittle zur gegebenen kleineren Strecke
    die groessere Strecke, sodass diese
    groessere Strecke zur kleineren im
    Goldenen Schnitt (Verhaeltnis) steht
    g == gross; k == klein
    g:k = (g+k):g#goldener Schnitt
    k ist bekannt, ergo
    g^2 - k*g - k^2 == 0
    (Vieta Formel)
    '''
    q = klein**2
    minusphalbe = klein/2
    wurzel = ( (klein**2)/4 + q )**0.5
    return minusphalbe + wurzel

def main():
    farben = ['black','red','blue']
    durchlaeufe = len(farben)*2
    turtle.reset()
    turtle.ht() #hide turtle --> ht()
    turtle.setup(2400,1200)
    fenster = turtle.Screen()
    fenster.title('goldener Schnitt')
    turtle.pensize(3)
    step = 0.1
    #farbe = ['black','red','green','blue','orange','yellow','violet','cyan']
    fenster.onkey( bye, 'q' )
    for durchlauf in range(durchlaeufe):
        shuffle(farben)
        for i in range( len(farben) ):
            turtle.pencolor(farben[i])
            turtle.circle( step, 180)
            #step = step + get_grossgold(step)
#radius-neu muss sein 'alter step' plus get_grossgold(step)
            kleiner = step
            step = get_grossgold(step)
            print( step/kleiner )
    fenster.listen()
    fenster.mainloop()

if __name__ == '__main__':
    main()
