#! /usr/bin/env python3

'''
eingegebene Zahl ist Obergrenze, bis zu welcher von 1 weg alle natuerlichen Zahlen gecheckt werden sollen, ob deren binaere Darstellung (0,1) ein Paleondron bilden, oder nicht

changelog zu 001:
eval() in Zusammenhang mit input() kann exploited werden, daher 
sollte es so nicht eingesetzt werden!!
'''

__author__ = 'michael poeltl'
__version__ = '0.02'
__copyright__ = 'poeltl (c) 2013'
__license__ = 'GPLv2'

from pprint import pprint

def is_pal(x):
    bitstring = bin(x)[2:]
    if len(bitstring) == 1:
        return False
    while True:
        a = bitstring[0]
        b = bitstring[-1]
        bitstring = bitstring[1:-1]
        if a != b:
            return False
        elif len(bin(x)[2:])%2 and len(bitstring) == 1:
            return True
        elif len(bitstring) == 0:
            return True
def main():
    print ("Wir wollen natuerliche Zahlen (ein gewisser vorgegebener Bereich) finden, deren bitstring ein Paleondrom darstellt.")
    print ('''Die Zahl, bis zu welcher gecheckt werden soll, soll eine natuerliche Zahl ohne Null sein.
''')
    while True:
        try:
            zahl = int( input("Natuerliche zahlen checken bis zu: "))
            if zahl <= 0:
                raise ValueError("Ihre Zahl ist keine Zahl der Menge N ohne Null!")
            else:
                break
        except ValueError as e:
            print("Fehlerhafte Eingabe. {}".format( e ))
            continue
    sammel = []
    for i in range(1,zahl+1):
        if is_pal(i):
            sammel.append((i, bin(i)[2:]))
    pprint(sammel)

if __name__ == '__main__':
    main()
